// Source Code for KNL Programming Tutorial
// KISTI Intel(R) Parallel Programming Center 
#include <stdio.h>
#include <time.h>
#include <omp.h>
//#define N 800
#define N 800000000
#define VL 16

int main(int argc, char *argv[]) {
	srand(1);
	//srand(time(NULL));
	double time;
	int *age = (int*)_mm_malloc(sizeof(int)*N, 64);
	int *hist = (int*)_mm_malloc(sizeof(int)*5, 64);

	#pragma omp parallel for 
	for(int i=0; i<N; i++){
		age[i] = i % 100;
		//age[i] = rand() % 100;
	}
/////////////////////////////////////////////////
	for(int i=0; i<5; i++) hist[i] = 0;
	time = -omp_get_wtime();
	for(int i=0; i<N; i++) {
		int index = (int)(age[i] / 20);
		hist[index]++;
	}
	time += omp_get_wtime();
	printf("\t1 Histogram time: %lf (secs)\n", time);
	for(int i=0; i<5; i++) printf("\t\t%d\n", hist[i]);
	printf("\n");
/////////////////////////////////////////////////
	for(int i=0; i < 5; i++) hist[i] = 0;
	time = -omp_get_wtime();
	#pragma omp parallel
	{
		int *index = (int*)_mm_malloc(sizeof(int)*VL, 64);
		int hist_private[5];
		for(int i=0; i<5; i++) hist_private[i] = 0;
		#pragma omp for
		for(int i=0; i<N; i+=VL) {
			#pragma omp simd
			#pragma vector aligned
			for(int j=i; j<i+VL; j++)
				index[j-i] = (int)(age[j] / 20);

			for(int j=0; j<VL; j++)
				hist_private[index[j]]++;
		}
		#pragma omp critical
		{
			for(int i=0; i<5; i++)
				hist[i] += hist_private[i];
		}
		_mm_free(index);
	}
	time += omp_get_wtime();
	printf("\t2 Histogram time: %lf (secs)\n", time);
	for(int i=0; i<5; i++) printf("\t\t%d\n", hist[i]);
	printf("\n");
/////////////////////////////////////////////////
	_mm_free(age);
	_mm_free(hist);

	return 0;
}
