// Source Code for KNL Programming Tutorial
// KISTI Intel(R) Parallel Programming Center 

#include <stdio.h>
#include <omp.h>

#define N 100000000

void init(double *a, int n)
{
    for (size_t i = 0; i < n; i++)
        a[i] = (double)i;
}

double result(double *a, int n)
{
    double ret = 0.;
    for (size_t i = 0; i < n; i++)
        ret += a[i];
    return ret;
}

int main()
{
    double *a = malloc(sizeof *a * N);

    init(a, N);
    for (size_t i = 0; i < N - 1; i++)
        a[i] = a[i + 1];
    printf("write after read : %e\n", result(a, N));

    init(a, N);
    for (size_t i = 1; i < N; i++)
        a[i] = a[i - 1];
    printf("read after write : %e\n", result(a, N));
    
    init(a, N);
    #pragma simd
    for (size_t i = 0; i < N - 1; i++)
        a[i] = a[i + 1];
    printf("write after read (simd) : %e\n", result(a, N));

    init(a, N);
    #pragma simd
    for (size_t i = 1; i < N; i++)
        a[i] = a[i - 1];
    printf("read after write (simd) : %e\n", result(a, N));

    free(a);
    return 0;
}
