// Source Code for KNL Programming Tutorial
// KISTI Intel(R) Parallel Programming Center 

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 100000000

int main()
{
    
    struct { double x; double y; } *point = malloc(sizeof *point * N);
    struct { double *x; double *y; } set;
    set.x = malloc(sizeof *(set.x) * N);
    set.y = malloc(sizeof *(set.y) * N);

    for (int i = 0; i < N; i++) {
        point[i].x = (double)(i);
        point[i].y = 0.;
        set.x[i] = (double)(i);
        set.y[i] = 0.;
    }

    double time = -omp_get_wtime();
    for (int i = 0; i < N; i++)
        point[i].y = 2. * point[i].x;
    time += omp_get_wtime();
    printf("Array of Structure: %f (secs)\n", time);

    time = -omp_get_wtime();
    for (int i = 0; i < N; i++)
        set.y[i] = 2. * set.x[i];
    time += omp_get_wtime();
    printf("Structure of Array: %f (secs)\n", time);

    free(point);
    free(set.x);
    free(set.y);

    return 0;
}
