
if [ $# -lt 1 ]
then
        echo "please, give one of numbers; 1, 2, or 3"
fi
case "$1" in 

1) 
    #01_MMmul
    icc 01_MMmul/MMmul.c -std=c11 -qopt-report=5 -O2 -no-vec -qopenmp -o 01_MMmul/MMmul_O2.ex
    mv 01_MMmul/MMmul.optrpt 01_MMmul/MMmul_O2.optrpt
    
    icc 01_MMmul/MMmul.c -std=c11 -qopt-report=5 -O3 -no-vec -qopenmp -o 01_MMmul/MMmul_O3.ex
    mv 01_MMmul/MMmul.optrpt 01_MMmul/MMmul_O2_AVX512.optrpt
    
    icc 01_MMmul/MMmul.c -std=c11 -qopt-report=5 -O3 -qopenmp -xMIC-AVX512 -o 01_MMmul/MMmul_O3_AVX512.ex
    mv 01_MMmul/MMmul.optrpt 01_MMmul/MMmul_O3_AVX512.optrpt

    icc 01_MMmul/MMmul.c -std=c11 -qopt-report=5 -O3 -qopenmp -xMIC-AVX512 -DHAVE_CBLAS -mkl -o 01_MMmul/MMmul_MKL.ex
    mv 01_MMmul/MMmul.optrpt 01_MMmul/MMmul_MKL.optrpt
    ;;
2)     
    #02_VVdot
    icc 02_VVdot/VVdot.c -std=c11 -O0 -qopt-report=5 -qopenmp -no-vec -o 02_VVdot/VVdot_O0.ex
    mv 02_VVdot/VVdot.optrpt 02_VVdot/VVdot_O0.optrpt
    
    icc 02_VVdot/VVdot.c -std=c11 -O1 -qopt-report=5 -qopenmp -no-vec -o 02_VVdot/VVdot_O1.ex
    mv 02_VVdot/VVdot.optrpt 02_VVdot/VVdot_O1.optrpt
    
    icc 02_VVdot/VVdot.c -std=c11 -O2 -qopt-report=5 -qopenmp -no-vec -o 02_VVdot/VVdot_O2.ex
    mv 02_VVdot/VVdot.optrpt 02_VVdot/VVdot_O2.optrpt
    
    icc 02_VVdot/VVdot.c -std=c11 -O2 -qopt-report=5 -qopenmp -xMIC-AVX512 -o 02_VVdot/VVdot_O2_AVX512.ex
    mv 02_VVdot/VVdot.optrpt 02_VVdot/VVdot_O2_AVX512.optrpt
    
    icc 02_VVdot/VVdot.c -std=c11 -O3 -qopt-report=5 -qopenmp -xMIC-AVX512 -o 02_VVdot/VVdot_O3_AVX512.ex
    mv 02_VVdot/VVdot.optrpt 02_VVdot/VVdot_O3_AVX512.optrpt
    ;;
3)
    #03_Histogram
    icc 03_Histogram/Histogram.c -std=c11 -qopt-report=5 -O2 -qopenmp -no-vec -o 03_Histogram/Histogram_O2.ex
    mv 03_Histogram/Histogram.optrpt 03_Histogram/Histogram_O2.optrpt
    
    icc 03_Histogram/Histogram.c -std=c11 -qopt-report=5 -O2 -qopenmp -xMIC-AVX512 -o 03_Histogram/Histogram_O2_AVX512.ex
    mv 03_Histogram/Histogram.optrpt 03_Histogram/Histogram_O2_AVX512.optrpt
    
    icc 03_Histogram/Histogram.c -std=c11 -qopt-report=5 -O3 -qopenmp -xMIC-AVX512 -o 03_Histogram/Histogram_O3_AVX512.ex
    mv 03_Histogram/Histogram.optrpt 03_Histogram/Histogram_O3_AVX512.optrpt
    ;;
*)
    echo "Wrong argument. please check"
    ;;
esac 
